import { Client, ClientOptions, Collection, Message, MessageEmbed } from "discord.js";
import { CommandCategory, FishyApplicationCommand, FishyApplicationCommandOption, FishyClientOptions, FishyCommand, FishyComponentCommand } from "./types";
import { Model } from "mongoose";
export declare class FishyClient extends Client {
    fishy_options: FishyClientOptions;
    GuildModel: Model<any, any>;
    commands: Collection<string, FishyCommand>;
    componentCommands: Collection<string, FishyComponentCommand>;
    categories: Collection<string, CommandCategory>;
    constructor(options: FishyClientOptions, client_options?: ClientOptions);
    load_events(directory?: string): Promise<unknown>;
    load_commands(directory?: string): Promise<unknown>;
    load_interactions(force_update?: boolean, user_id?: string): Promise<void>;
    load_commandhandler(): Promise<void>;
    help_command(): Promise<FishyCommand>;
    load_silence_command(): void;
    load_commands_command(): void;
    load_db(): Promise<void>;
    load_error_handler(): Promise<void>;
    load_message_handlers(): Promise<void>;
    logToChannel(message: string | MessageEmbed): Promise<Message | undefined>;
    load(): Promise<void>;
}
export declare function generateUsage(title: string, config: FishyApplicationCommand | FishyApplicationCommandOption, types?: boolean): string;
