"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.config = exports.run = void 0;
const client_1 = require("../client");
const types_1 = require("../types");
const run = async (client, interaction) => {
    function sortCatsOnKeys(dict) {
        var sorted = [];
        for (var key in dict) {
            sorted[sorted.length] = key;
        }
        sorted.sort();
        var tempDict = {};
        for (var i = 0; i < sorted.length; i++) {
            tempDict[sorted[i]] = dict[sorted[i]];
        }
        return tempDict;
    }
    let cats = {};
    let index_string = `[0]: Index
[Index][0]`;
    let commands_string = ``;
    client.categories.forEach((category) => {
        if (category.name.toLowerCase() == "debug")
            return;
        if (category.commands?.[0]) {
            const commands = [];
            category.commands.forEach((cmd_name) => {
                const cmd = client.commands.get(cmd_name);
                let command;
                const interaction = cmd?.config.interaction_options;
                if (!cmd || !interaction)
                    return commands.push({ name: `${cmd_name}`, usage: `${cmd_name}` });
                else if (interaction.options?.find((opt) => opt.type === types_1.ApplicationCommandOptionType.SUB_COMMAND ||
                    opt.type === types_1.ApplicationCommandOptionType.SUB_COMMAND_GROUP)) {
                    let cmds = [];
                    interaction.options.forEach((opt) => {
                        if (opt.type === types_1.ApplicationCommandOptionType.SUB_COMMAND) {
                            cmds.push({
                                name: `${cmd_name} ${opt.name}`,
                                usage: client_1.generateUsage(`${cmd_name} ${opt.name}`, opt),
                            });
                        }
                        else if (opt.type === types_1.ApplicationCommandOptionType.SUB_COMMAND_GROUP && opt.options?.[0]) {
                            opt.options.forEach((opt2) => {
                                if (opt2.type === types_1.ApplicationCommandOptionType.SUB_COMMAND) {
                                    cmds.push({
                                        name: `${cmd_name} ${opt.name} ${opt2.name}`,
                                        usage: client_1.generateUsage(`${cmd_name} ${opt.name} ${opt2.name}`, opt2),
                                    });
                                }
                            });
                        }
                    });
                    return commands.push(...cmds);
                }
                else {
                    return commands.push({ name: `${cmd_name}`, usage: client_1.generateUsage(`${cmd_name}`, interaction) });
                }
            });
            if (cats[category.name])
                cats[category.name].push(...commands);
            else
                cats[category.name] = commands;
        }
    });
    cats = sortCatsOnKeys(cats);
    Object.keys(cats).forEach((catname) => {
        cats[catname].sort();
        const index = Object.keys(cats).findIndex((key) => key == catname) + 1;
        index_string = index_string.concat("\n", `[${catname}][${index}]`);
        let cat_string = `\n\n[${index}]: ${catname}`;
        cats[catname].forEach((command) => {
            let command_string = `\n/${command.usage}`;
            cat_string = cat_string.concat(command_string);
        });
        commands_string = commands_string.concat(cat_string);
    });
    return interaction.send(`\`\`\`markdown
[FishyBot](https://github.com/Fish-o/FishyBotV2)\n/commandname subcommand <required> (optional)\n\n${index_string} ${commands_string}\`\`\``);
};
exports.run = run;
exports.config = {
    name: "commands",
    bot_needed: false,
    interaction_options: {
        name: "commands",
        description: "Display all commands of the bot",
        options: [],
    },
};
