"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.config = exports.isSilent = exports.run = void 0;
const types_1 = require("../types");
const SilenceCache = new Map();
const run = async (client, interaction) => {
    const old = SilenceCache.get(interaction.raw_member?.user?.id || "");
    let new_val = true;
    if (old) {
        new_val = !old;
    }
    let found = interaction.data.options.find((opt) => opt.name == "silenced")?.value;
    if (typeof found === "boolean") {
        new_val = found;
    }
    SilenceCache.set(interaction.raw_member?.user?.id || "", new_val);
    if (!new_val)
        return interaction.sendSilent(`Turned silence mode **off**!`);
    else if (new_val)
        return interaction.sendSilent(`Turned silence mode **on**!`);
};
exports.run = run;
const isSilent = (memberId) => {
    return SilenceCache.get(memberId) || false;
};
exports.isSilent = isSilent;
exports.config = {
    name: "silence",
    bot_needed: false,
    interaction_options: {
        name: "silence",
        description: "Make the bot only respond with ephemeral messages",
        options: [
            {
                name: "silenced",
                description: "If the it is set to silence or not",
                type: types_1.ApplicationCommandOptionType.BOOLEAN,
            },
        ],
    },
};
