"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const axios_1 = __importDefault(require("axios"));
const types_1 = require("../types");
const ComponentMessage_1 = __importDefault(require("./ComponentMessage"));
const Interaction_1 = require("./Interaction");
class ButtonInteraction extends Interaction_1.Interaction {
    constructor(client, raw_button_interaction) {
        super(client, raw_button_interaction);
        this._raw_button_interaction = raw_button_interaction;
        this.data = raw_button_interaction.data;
    }
    get message() {
        const channel = this.channel;
        if (!channel?.isText())
            throw new Error("Channel is not a text channel");
        return this._message || new ComponentMessage_1.default(this.client, this._raw_button_interaction.message, channel);
    }
    async updateMessage(message, options) {
        if (!options) {
            options = {};
        }
        if (typeof message !== "string" && typeof options !== "string") {
            if (!options) {
                options = { embeds: [message] };
            }
            else if (options.embeds) {
                options.embeds.push(message);
            }
            else {
                options.embeds = [message];
            }
            message = "";
        }
        else if (typeof message == "string" && typeof options !== "string") {
            options.content = message;
        }
        this.response_used = true;
        return await axios_1.default.patch(`https://discord.com/api/v9/interactions/${this.id}/${this.token}/callback`, {
            type: types_1.InteractionResponseType.UpdateMessage,
            data: options,
        });
    }
    async deferUpdateMessage() {
        this.response_used = true;
        return await axios_1.default.post(`https://discord.com/api/v9/interactions/${this.id}/${this.token}/callback`, {
            type: types_1.InteractionResponseType.DeferredUpdateMessage,
        });
    }
}
exports.default = ButtonInteraction;
