import { GuildMember, MessageEmbed, User } from "discord.js";
import { FishyClient } from "..";
import { guild_member_object, InteractionApplicationCommandCallbackData, InteractionType, raw_received_interaction, user_object, webhookOptions } from "../types";
import { AxiosResponse } from "axios";
import * as DbUtils from "../utils/DbUtils";
export declare class Interaction {
    client: FishyClient;
    raw_interaction: raw_received_interaction;
    data: any;
    id: string;
    token: string;
    type: InteractionType;
    guild_id?: string;
    channel_id?: string;
    raw_member?: guild_member_object;
    raw_user: user_object;
    response_used: boolean;
    constructor(client: FishyClient, raw_interaction: raw_received_interaction);
    send(message?: string | MessageEmbed, options?: InteractionApplicationCommandCallbackData): Promise<AxiosResponse<any>>;
    sendSilent(message?: string | MessageEmbed, options?: InteractionApplicationCommandCallbackData): Promise<AxiosResponse<any>>;
    defer(): Promise<AxiosResponse<any>>;
    edit(message: string | MessageEmbed, options?: InteractionApplicationCommandCallbackData | string, message_id?: string): Promise<AxiosResponse<any>>;
    delete(message_id?: string): Promise<AxiosResponse<any>>;
    send_webhook(message?: string | MessageEmbed, options?: webhookOptions): Promise<AxiosResponse<any>>;
    get channel(): import("discord.js").TextChannel | import("discord.js").NewsChannel | undefined;
    get guild(): import("discord.js").Guild | undefined;
    get member(): GuildMember | undefined;
    get user(): User;
    getDbGuild(options?: DbUtils.db_fetch_options): Promise<any>;
    updateDbGuild(model: any): Promise<void>;
}
