import { Channel, Collection, Guild, GuildMember, Role, User } from "discord.js";
import { FishyClient } from "..";
import { ApplicationCommandInteractionData, ApplicationCommandInteractionDataOption, ApplicationCommandInteractionResolved } from "../types";
export declare class InteractionData {
    id: string;
    name: string;
    resolved: ApplicationCommandInteractionResolved | undefined;
    data: ApplicationCommandInteractionData;
    client: FishyClient;
    guild: Guild | undefined;
    constructor(client: FishyClient, data: ApplicationCommandInteractionData, guild?: Guild);
    get options(): InteractionDataOption[];
    get mentions(): InteractionDataMentions | undefined;
}
export declare class InteractionDataMentions {
    data: ApplicationCommandInteractionResolved;
    client: FishyClient;
    guild: Guild | undefined;
    constructor(client: FishyClient, resolve_data: ApplicationCommandInteractionResolved, guild?: Guild);
    get channels(): Collection<string, Channel> | undefined;
    get members(): Collection<string, GuildMember> | undefined;
    get users(): Collection<string, User> | undefined;
    get roles(): Collection<string, Role> | undefined;
}
export declare class InteractionDataOption {
    data: ApplicationCommandInteractionDataOption;
    name: string;
    value: string | number | boolean | undefined;
    type: import("../types").ApplicationCommandOptionType;
    constructor(data: ApplicationCommandInteractionDataOption);
    get options(): InteractionDataOption[];
}
