"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.update = exports.fetch = void 0;
const discord_js_1 = require("discord.js");
const db_guild_cache = new discord_js_1.Collection();
const ttl = 5 * 60 * 1000;
const refresh_time = 20 * 1000;
async function refresh(client, guild_id, options, count) {
    let db_res = await client.GuildModel.findOne({ id: guild_id });
    if (!db_res) {
        if (!client.fishy_options.disable_db_default_upsert && !options?.disable_upsert && count !== 1) {
            const new_model = new client.GuildModel({ id: guild_id });
            await new_model.save();
            return await refresh(client, guild_id, options, (count = 1));
        }
        else {
            throw Error(`Could not find the database document of "${guild_id}"`);
        }
    }
    let answer = { timestamp: Date.now(), data: db_res };
    db_guild_cache.set(guild_id, answer);
    return answer.data;
}
function fetch(client, guild_id, options) {
    return new Promise(async (resolve, reject) => {
        if (!guild_id) {
            return;
        }
        if (!db_guild_cache.has(guild_id) || db_guild_cache.get(guild_id).timestamp + ttl < Date.now())
            return resolve(await refresh(client, guild_id, options));
        else if (db_guild_cache.get(guild_id).timestamp + refresh_time < Date.now()) {
            resolve(db_guild_cache.get(guild_id)?.data);
            return await refresh(client, guild_id, options);
        }
        else {
            return resolve(db_guild_cache.get(guild_id)?.data);
        }
    });
}
exports.fetch = fetch;
async function update(client, guild_id, model) {
    let res = await client.GuildModel.updateOne({ id: guild_id }, model);
    //db_guild_cache.set(guild_id, { timestamp: Date.now(), data: res });
}
exports.update = update;
